﻿Public Class Form1
    Dim dt As New DataTable()

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dt.Columns.Add("ID")
        dt.Columns.Add("Name")
        dt.Columns.Add("Married", GetType(Boolean))

        dt.Rows.Add(1, "A", True)
        dt.Rows.Add(2, "B", False)
        dt.Rows.Add(3, "C", True)
        dt.Rows.Add(4, "D", False)
        dt.Rows.Add(5, "E", False)
        dt.Rows.Add(6, "F", True)
        dt.Rows.Add(7, "G", True)
        dt.Rows.Add(8, "H", False)

        C1FlexGrid1.DataSource = dt
        C1FlexGrid1.SetCellCheck(0, 3, C1.Win.C1FlexGrid.CheckEnum.Checked)
        C1FlexGrid1.AllowSorting = C1.Win.C1FlexGrid.AllowSortingEnum.None
    End Sub

    Private Sub C1FlexGrid1_CellChecked(sender As Object, e As C1.Win.C1FlexGrid.RowColEventArgs) Handles C1FlexGrid1.CellChecked
        If e.Row = 0 AndAlso e.Col = 3 Then
            ChangeState(C1FlexGrid1.GetCellCheck(e.Row, e.Col))
        Else
            If C1FlexGrid1.GetCellCheck(e.Row, e.Col) = C1.Win.C1FlexGrid.CheckEnum.Unchecked Then
                C1FlexGrid1.SetCellCheck(0, 3, C1.Win.C1FlexGrid.CheckEnum.Unchecked)
            End If
        End If
    End Sub

    Private Sub ChangeState(state As C1.Win.C1FlexGrid.CheckEnum)
        For row As Integer = c1FlexGrid1.Rows.Fixed To c1FlexGrid1.Rows.Count - 1
            c1FlexGrid1.SetCellCheck(row, 3, state)
        Next
    End Sub

End Class
